//labfinalproj.c 
//video gen and sound
//D.5 is sync:1000 ohm + diode to 75 ohm resistor
//D.6 is video:330 ohm + diode to 75 ohm resistor  
//B.3 is sound  and should have a 10k resistor to gnd

#pragma regalloc-    //I allocate the registers myself
#pragma optsize-     //optimize for speed
                    
#include <Mega32.h>   
#include <stdio.h>
#include <stdlib.h> 
#include <math.h> 
#include <delay.h>   

//cycles = 63.625 * 16 Note NTSC is 63.55 
//but this line duration makes each frame exactly 1/60 sec
//which is nice for keeping a realtime clock 
#define lineTime 1018
 
#define begin {
#define end   }
#define ScreenTop 30
#define ScreenBot 230

//NOTE that v1 to v8 and i must be in registers!  
register char v1 @4; 
register char v2 @5;
register char v3 @6;
register char v4 @7;
register char v5 @8;
register char v6 @9;
register char v7 @10;
register char v8 @11; 
register int i @12;

#pragma regalloc+ 

char syncON, syncOFF; 
int LineCount;
int time, time2, trandomN,posrandom, posrange, seprandom, seprange, speedrandom,speedrange, seed,NM1,NM2; 
char ji, jim1,jim2, jim, r;
//animation
char x1[3], y1[3],s1, startptx1[3], startpty1[3], oldx1[3], oldy1[3], x2[3];
char y2[3],s2, startptx2[3], startpty2[3], oldx2[3], oldy2[3], xship, yship, oldxship[3], oldyship[3];
char savedstate, explosion[3], explosioncount[3], savedexpcount, exwidth[3], eywidth[3];
char screen[1600], t,test[10], ts[10], ps[10], ns[10], timebase[8],taskdone[8], citydes[6], inc[3];      
int erase,points, Nscreen, x1speed[3], y1speed[3], x2speed[3], y2speed[3],vx1[3], vy1[3], vx2[3], vy2[3], yshipspeed, xshipspeed, vxship, vyship;
char cityloc[] = {3, 3+16, 3+32, 3+32+18+15+12, 3+32+18+15+18+12 , 3+32+18+15+18+12+16};
char cu1[]="MISSILE"; 
char cu2[]="COMMAND";    
char cu3[]="JAMES";
char cu4[] = "PRUDHOMME"; 
char cu5[] = "GAME";
char cu6[] = "OVER";
char cu7[] = "LEVEL";  
char cu8[] = "PAUSED"; 

// button control
enum BoolEnum{FALSE,TRUE};        
typedef enum BoolEnum BOOL;
enum ButtonNameEnum{StartButton, Down,Up, Right, Left, Fire};   
enum PushState{NoPush, MaybePush, Push, MaybeNoPush};
enum PushState debouncedState[6];
BOOL isPushed[6];    
#define ONLYBUTTON(P,i)	 ((~P) & ((0x01)<<i)) ==((0x01)<<i)     
bit pressedstart;
//game state machine

int current_state;                                          
enum begin INTRO, CITIESSHIPS, MISSILES, ENDLEVEL, CITYDESTROYED, GAMEOVER, PAUSED end;
char mdestroyed1[3],mdestroyed2[3],totalmdestroyed1, totalmdestroyed2;
int missileslaunched,TotalMissiles, yourmissiles, basemissiles, baseloc,MissileDone[3], MissileTracked[3], citiesdestroyed, Missilenum;
//BOOL misslesremaing[30], misslesdestroyed[30];
char HitTarget1[3],HitTarget2[3], CityHit, fired;
int NextLevel;       

#define TIMECONTROL(STRING, N) { \
			if (++timebase[STRING] > N) {      \ 
    			timebase[STRING] =0;\
   			taskdone[STRING] = 0;\
    			}\
    			}
#define TASKS(STR, TD)   (timebase[STR]==TD) & (taskdone[STR]==TD)
#include "myvideoGen.c"  
#include "morefunc.c"
#include "gameGen.c"  


//==================================
//This is the sync generator and raster generator. It MUST be entered from 
//sleep mode to get accurate timing of the sync pulses
#pragma warn-
interrupt [TIM1_COMPA] void t1_cmpA(void)  
begin 
  //start the Horizontal sync pulse    
  PORTD = syncON;     
  //update the curent scanline number
  LineCount ++ ;   
  //begin inverted (Vertical) synch after line 247
  if (LineCount==248)
  begin 
    syncON = 0b00100000;
    syncOFF = 0;
  end
  //back to regular sync after line 250
  if (LineCount==251)	
  begin
    syncON = 0;
    syncOFF = 0b00100000;
  end  
  //start new frame after line 262
  if (LineCount==263) 
  begin
     LineCount = 1;
  end  
  
  delay_us(2); //adjust to make 5 us pulses
  //end sync pulse
  PORTD = syncOFF;   
  
  if (LineCount<ScreenBot && LineCount>=ScreenTop) 
    begin 
       
       //compute byte index for beginning of the next line
       //left-shift 4 would be individual lines
       // <<3 means line-double the pixels 
       //The 0xfff8 truncates the odd line bit
       //i=(LineCount-ScreenTop)<<3 & 0xfff8; //
       
       #asm
       push r16
       lds   r12, _LineCount
       lds   r13, _Linecount+1
       ldi   r16, 30
       sub  r12, r16 
       ldi  r16,0
       sbc  r13, r16 
       lsl  r12
       rol  r13
       lsl  r12
       rol  r13
       lsl  r12    
       rol  r13
       mov  r16,r12
       andi r16,0xf0
       mov  r12,r16
       pop r16 
       #endasm
        
       //load 16 registers with screen info
       #asm
       push r14
       push r15
       push r16
       push r17
       push r18 
       push r19 
       push r26
       push r27
       
       ldi  r26,low(_screen)   ;base address of screen
       ldi  r27,high(_screen)   
       add  r26,r12            ;offset into screen (add i)
       adc  r27,r13
       ld   r4,x+   	       ;load 16 registers and inc pointer
       ld   r5,x+
       ld   r6,x+  
       ld   r7,x+
       ld   r8,x+ 
       ld   r9,x+
       ld   r10,x+  
       ld   r11,x+
       ld   r12,x+ 
       ld   r13,x+
       ld   r14,x+  
       ld   r15,x+
       ld   r16,x+   
       ld   r17,x+  
       ld   r18,x+
       ld   r19,x 
       
       pop  r27
       pop  r26
       #endasm  

       delay_us(4);  //adjust to center image on screen
       
       //blast 16 bytes to the screen   
       #asm
       ;but first a macro to make the code shorter  
       ;the macro takes a register number as a parameter
       ;and dumps its bits serially to portD.6   
       ;the nop can be eliminated to make the display narrower
       .macro videobits ;regnum
        BST  @0,7
	IN   R30,0x12
	BLD  R30,6
	nop
	OUT  0x12,R30  
	
	BST  @0,6
	IN   R30,0x12
	BLD  R30,6
	nop
	OUT  0x12,R30 
	
	BST  @0,5
	IN   R30,0x12
	BLD  R30,6 
	nop
	OUT  0x12,R30 
	
	BST  @0,4
	IN   R30,0x12
	BLD  R30,6
	nop
	OUT  0x12,R30 
	
	BST  @0,3
	IN   R30,0x12
	BLD  R30,6
	nop
	OUT  0x12,R30 
	
	BST  @0,2
	IN   R30,0x12
	BLD  R30,6
	nop
	OUT  0x12,R30 
	
	BST  @0,1
	IN   R30,0x12
	BLD  R30,6 
	nop
	OUT  0x12,R30 
	
	BST  @0,0
	IN   R30,0x12
	BLD  R30,6
	nop
	OUT  0x12,R30 
       .endm     
        
	videobits r4 ;video line -- byte 1
        videobits r5 ;byte 2  
        videobits r6 ;byte 3
        videobits r7 ;byte 4
        videobits r8 ;byte 5
        videobits r9 ;byte 6
        videobits r10 ;byte 7
        videobits r11 ;byte 8 
        videobits r12 ;byte 9
        videobits r13 ;byte 10  
        videobits r14 ;byte 11
        videobits r15 ;byte 12
        videobits r16 ;byte 13
        videobits r17 ;byte 14
        videobits r18 ;byte 15
        videobits r19 ;byte 16
	clt   ;clear video after the last pixel on the line
	IN   R30,0x12
	BLD  R30,6
	OUT  0x12,R30
								
       pop r19
       pop r18
       pop r17 
       pop r16  
       pop r15
       pop r14
       #endasm
              
    end     

       
end  
#pragma warn+

//==================================


//==================================
// set up the ports and timers
void main(void)
begin   
 
  INITIALIZE();          //Initialize variables
  
  //The following loop executes once/video line during lines
  //1-230, then does all of the frame-end processing
  while(1)
  begin
  
    //stall here until next line starts
    //sleep enable; mode=idle  
    //use sleep to make entry into sync ISR uniform time  
     
    #asm ("sleep"); 
    
    //The following code executes during the vertical blanking
    //Code here can be as long as  
    //a total of 60 lines x 63.5 uSec/line x 8 cycles/uSec 
    
    if (LineCount==231)
    begin 
        
        //Play a note
       //TCCR0 bits:
       //bit 7 no force:
       //bit 3 CTC on: 
       //bit 5,4 toggle OC0 pin   
       //bit 6 no PWM
       //bit 2-0 prescaler 256 so 1 tick is 16 microsec    
       		    
            
       if ((++t>59)) 
       begin   
     
           t=0;     
           time2 = time2+1;
          // time = time + 1;      
           
          
            ////////////Display points 
                  if (current_state== MISSILES || current_state== GAMEOVER) begin
           sprintf(ps,"%07d",points);
           video_putsmalls(84,1,ps);   
                               end
        //   sprintf(test,"%05d", TotalMissiles);//(y1speed >>8));
        //   video_putsmalls(92,14,test);
         end
              
    
          
    
    
         ////////////////  
		 GAMESTATEMACHINE();       // Run state machine that controls entire game

     end  //line 231
  end  //while
end  //main


